// rollup.config.mjs
import json from "@rollup/plugin-json";
// import terser from "@rollup/plugin-terser";
import babel from "@rollup/plugin-babel";
import commonjs from "rollup-plugin-commonjs";
import { nodeResolve } from "@rollup/plugin-node-resolve";
import livereload from "rollup-plugin-livereload"; // hot
import serve from "rollup-plugin-serve";
// to file
const buildFile = "./lib/";

export default {
  input: "src/main.js",
  output: [
    {
      file: buildFile + "bundle.cjs.js",
      format: "cjs",
      sourcemap: true,
    },
    {
      format: "es",
      file: "lib/bundle.esm.js",
      sourcemap: true,
    },
    // {
    //   file: buildFile + "bundle.min.js",
    //   format: "iife",
    //   name: "version",
    //   plugins: [terser()],
    // },
  ],
  plugins: [
    json(),
    commonjs({
      include: ["node_modules"],
    }),
    nodeResolve({
      browser: true,
      moduleDirectories: ["node_modules"],
    }),
    // babel 配置
    babel({
      // runtimeHelpers: true,
      // 只转换源代码，不运行外部依赖
      exclude: "node_modules/**",
      // babelHelpers: "bundled",
    }),
    // server
    livereload(),
    serve({
      open: true,
      port: 10811,
      contentBase: ["", "./public"],
    }),
  ],
};
