import fetchData from "./fetchFun";
import createInstance from "./instance";

const createFetch = ({ requestIntercept, responseIntercept, requestConfig, loading }) => {
  let instance = createInstance({ requestConfig });

  if (!requestConfig) throw "please add requestConfig";

  //将封装的数据分发下来
  const fetch = ["get", "post", "delete", "put", "patch"].reduce((pre, cur) => {
    return {
      ...pre,
      [cur](url, data, config) {
        return fetchData(instance, { method: cur, url, data, config }, loading); // 请求方式
      },
    };
  }, {});

  // 拦截器规范
  if (requestIntercept) {
    let [requestFunc, errorFunc] = requestIntercept();
    instance.interceptors.request.use(requestFunc, errorFunc);
  }
  if (responseIntercept) {
    let [responseFunc, errorFunc] = requestIntercept();
    instance.interceptors.response.use(responseFunc, errorFunc);
  }

  return { fetch, instance };
};

export default createFetch;
