class RequestQueue {
  queue = new Map();

  constructor() {
    if (RequestQueue.instance) {
      return RequestQueue.instance;
    }

    RequestQueue.instance = this;
  }

  // 获取queque
  getQueue() {
    return this.queue;
  }

  // 生成队列的key
  createMapKey(method, path, data) {
    let params = data ? `-${JSON.stringify(data)}` : "";
    return `${method}-${path}` + params;
  }

  // 中断key
  abortive(key) {
    const controller = this.queue.get(key);
    controller?.abort();
    this.queue.delete(key); // 中断后移除该key
  }

  // 中断所有请求
  removeResAll() {
    this.queue.forEach((controller) => controller.abort());
    this.queue.clear(); // 清除队列
  }
}

let requestQueue = new RequestQueue();

export default requestQueue;
